unit Lock;

interface

uses
{$IFNDEF LINUX}
  Windows, Messages,
{$ENDIF}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBCtrls, ExtCtrls, Grids, DBGrids, StdCtrls, ToolWin, ComCtrls, Buttons, LiteDACVcl,
{$IFDEF FPC}
  LResources,
{$ENDIF}
  DemoFrame, DB, DBAccess, LiteAccess,
  {$IFNDEF FPC}MemDS{$ELSE}MemDataSet{$ENDIF};

type
  TLockFrame = class(TDemoFrame)
    LiteQuery1: TLiteQuery;
    DataSource1: TDataSource;
    ToolBar: TPanel;
    Panel5: TPanel;
    Memo1: TMemo;
    Panel6: TPanel;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel4: TPanel;
    Label1: TLabel;
    rbPessimistic: TRadioButton;
    rbOptimistic: TRadioButton;
    Panel3: TPanel;
    btClose: TSpeedButton;
    btOpen: TSpeedButton;
    DBGrid: TDBGrid;
    meSQL: TMemo;
    Panel11: TPanel;
    Panel12: TPanel;
    DBNavigator1: TDBNavigator;
    procedure btOpenClick(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure meSQLExit(Sender: TObject);
    procedure LiteQuery1AfterExecute(Sender: TObject; Result: Boolean);
    procedure rbOptimisticClick(Sender: TObject);
  private
    { Private declarations }
    procedure ShowState;
  public
    // Demo management
    procedure Initialize; override;
    procedure SetDebug(Value: boolean); override;
  end;

implementation

uses LiteDacDemoForm;

{$IFNDEF FPC}
{$IFDEF CLR}
{$R *.nfm}
{$ELSE}
{$R *.dfm}
{$ENDIF}
{$ENDIF}


procedure TLockFrame.ShowState;
var
  St:string;

  procedure AddSt(S:string);
  begin
    if St <> '' then
      St := St + ', ';
    St := St + S;
  end;

begin
  St := '';

  if LiteQuery1.Prepared then begin
    AddSt('Prepared');

    if LiteQuery1.IsQuery then
      AddSt('IsQuery');
  end;

  if LiteQuery1.Active then
    AddSt('Active')
  else
    AddSt('Inactive');

  if LiteQuery1.Executing then
    AddSt('Executing');

  if LiteQuery1.Fetching then
    AddSt('Fetching');

  LiteDacForm.StatusBar.Panels[1].Text := St;
end;

procedure TLockFrame.meSQLExit(Sender: TObject);
begin
  if Trim(LiteQuery1.SQL.Text) <> Trim(meSQL.Lines.Text) then
    LiteQuery1.SQL.Text := meSQL.Lines.Text;
  ShowState;
end;

procedure TLockFrame.btOpenClick(Sender: TObject);
begin
  if Trim(LiteQuery1.SQL.Text) <> Trim(meSQL.Lines.Text) then
    LiteQuery1.SQL.Text := meSQL.Lines.Text;
  try
    LiteQuery1.Open;
  finally
    ShowState;
  end;
end;

procedure TLockFrame.btCloseClick(Sender: TObject);
begin
  LiteQuery1.Close;
  ShowState;
end;

procedure TLockFrame.LiteQuery1AfterExecute(Sender: TObject; Result: Boolean);
begin
  ShowState;

  if Result then
    LiteDacForm.StatusBar.Panels[1].Text := LiteDacForm.StatusBar.Panels[1].Text + '   >>>> Success'
  else
    LiteDacForm.StatusBar.Panels[1].Text := LiteDacForm.StatusBar.Panels[1].Text + '   >>>> Fail';
end;

procedure TLockFrame.rbOptimisticClick(Sender: TObject);
begin
  if rbOptimistic.Checked then
    LiteQuery1.LockMode := lmOptimistic
  else
  if rbPessimistic.Checked then
    LiteQuery1.LockMode := lmPessimistic;
end;

// Demo management

procedure TLockFrame.Initialize;
begin
  LiteQuery1.Connection := Connection as TLiteConnection;
  meSQL.Lines.Assign(LiteQuery1.SQL);
  ShowState;
end;

procedure TLockFrame.SetDebug(Value: boolean);
begin
  LiteQuery1.Debug := Value;
end;

{$IFDEF FPC}
initialization
  {$i Lock.lrs}
{$ENDIF}
end.

