unit Text;

interface

uses
{$IFDEF FPC}
  LResources,
{$ENDIF}
{$IFNDEF LINUX}
  Windows, Messages,
{$ENDIF}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBCtrls, ExtCtrls, Db, Grids, DBGrids, StdCtrls, ToolWin, ComCtrls, Buttons,
  LiteDACVcl, DemoFrame, DBAccess, LiteAccess,
  {$IFNDEF FPC}MemDS{$ELSE}MemDataSet{$ENDIF};

type
  TTextFrame = class(TDemoFrame)
    DBGrid: TDBGrid;
    DataSource: TDataSource;
    ToolBar: TPanel;
    meText: TDBMemo;
    LiteQuery: TLiteQuery;
    Splitter1: TSplitter;
    ToolBar1: TPanel;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    ToolButton1: TToolButton;
    Panel1: TPanel;
    DBNavigator: TDBNavigator;
    btClose: TSpeedButton;
    btOpen: TSpeedButton;
    Panel2: TPanel;
    btClear: TSpeedButton;
    btSave: TSpeedButton;
    btLoad: TSpeedButton;
    procedure btOpenClick(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure btLoadClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure btClearClick(Sender: TObject);
  private
    { Private declarations }
  public
    // Demo management
    procedure Initialize; override;
    procedure SetDebug(Value: boolean); override;
  end;

implementation

{$IFNDEF FPC}
{$IFDEF CLR}
{$R *.nfm}
{$ELSE}
{$R *.dfm}
{$ENDIF}
{$ENDIF}

procedure TTextFrame.btOpenClick(Sender: TObject);
begin
  LiteQuery.Open;
end;

procedure TTextFrame.btCloseClick(Sender: TObject);
begin
  LiteQuery.Close;
end;

procedure TTextFrame.btLoadClick(Sender: TObject);
begin
  if LiteQuery.Active and OpenDialog.Execute then begin
    if LiteQuery.State = dsBrowse then
      LiteQuery.Edit;

    TBlobField(LiteQuery.FieldByName('TextField')).LoadFromFile(OpenDialog.FileName);
  end;
end;

procedure TTextFrame.btSaveClick(Sender: TObject);
begin
  if not (LiteQuery.Eof and LiteQuery.Bof) and SaveDialog.Execute then
    TBlobField(LiteQuery.FieldByName('TextField')).SaveToFile(SaveDialog.FileName);
end;

procedure TTextFrame.btClearClick(Sender: TObject);
begin
  if LiteQuery.Active then begin
    if LiteQuery.State = dsBrowse then
      LiteQuery.Edit;
    LiteQuery.FieldByName('TextField').Clear;
  end;
end;

// Demo management
procedure TTextFrame.Initialize;
begin
  inherited;
  LiteQuery.Connection := Connection as TLiteConnection;
end;

procedure TTextFrame.SetDebug(Value: boolean);
begin
  LiteQuery.Debug := Value;
end;

{$IFDEF FPC}
initialization
  {$i Text.lrs}
{$ENDIF}
end.
